﻿var tid = null;
var notifyDialog = (Ti.Platform.osname == 'android')
 ? Ti.UI.createNotification({duration: Ti.UI.NOTIFICATION_DURATION_LONG})
 : Ti.UI.createAlertDialog({title: 'Nortify'});
var notify = function (message) {
	notifyDialog.hide();
	notifyDialog.message = message;
	if (Ti.Platform.osname == 'android' && parseFloat(Ti.version) >= 1.8) {	// Ti.UI.Notification.setMessage 1.8+ not work
		notifyDialog = Ti.UI.createNotification({message: message, duration: Ti.UI.NOTIFICATION_DURATION_LONG});
	}
	notifyDialog.show();
	if (Ti.Platform.osname != 'android') {
		if (tid) { clearTimeout(tid); }
		tid = setTimeout(function () { notifyDialog.hide(); }, 3000);
	}
};
var exitConfirm = false;
var exit = function (confirm) {
	if (confirm && ! exitConfirm) {
		exitConfirm = true;
		setTimeout(function () { exitConfirm = false; }, 3000);
		notify('もう一度押すと終了します。');
	} else {
		notifyDialog.hide();
		window.close();
	}
};
var window = Ti.UI.createWindow({
	fullscreen: false,	// with Activity for Android & statusBar on (see tiapp.xml if no need Activity)
	navBarHidden: true,	// with Activity for Android & titleBar off (see tiapp.xml if no need Activity)
	exitOnClose: true,	// App exit by hardware back key for Android
});
window.addEventListener('close', function (e) {
	Ti.Geolocation.removeEventListener('location', locationCallback);
});
window.addEventListener('android:back', function (e) {
	exit(true);
});
var layout = Ti.UI.createView({});
window.add(layout);
var webview = Ti.UI.createWebView({top:0, scalesPageToFit:true, url:'map.html'});
webview.addEventListener('load', function (e) {
	var receiver = (Ti.Platform.osname == 'android') ? Ti.Android.currentActivity : Ti.App;
	var resumed = (Ti.Platform.osname == 'android') ? 'resume' : 'resumed';
	receiver.addEventListener(resumed, function (e) {
		Ti.API.info(resumed + ' fire');
		Ti.Geolocation.removeEventListener('location', locationCallback);
		Ti.Geolocation.addEventListener('location', locationCallback);
	});
	receiver.addEventListener('pause', function (e) {
		Ti.API.info('pause fire');
		Ti.Geolocation.removeEventListener('location', locationCallback);
	});
	Ti.Geolocation.getCurrentPosition(function (e) {
		handleLocation(e);	// not set e.devicetime
	});
});
webview.addEventListener('error', function (e) {
	alert('サイトに接続できません。\nネット環境を確認してください。');
});
layout.add(webview);
var bar = Ti.UI.createView({layout:'horizontal', height:32, width:288, bottom:16});
layout.add(bar);
var index = 0;
var zoom = [16, 12, 8, 4];
var title = ['あるく', '馬車', '気球', '不死鳥'];
var button = [];
for (var n = 0; n < title.length; n++) {
	button[n] = Ti.UI.createButton({width:72, font:{fontSize:14}, title:title[n], index:n});
	button[n].addEventListener('click', function (e) {
		index = this.index;
		webview.evalJS('map.setZoom(' + zoom[index] + ')');
		location_r0.latitude = location_r1.latitude; 
		location_r0.longitude = location_r1.longitude;
		location_m0.latitude = location_m1.latitude; 
		location_m0.longitude = location_m1.longitude;
	});
	bar.add(button[n]);
}
window.open();
if (! Ti.Geolocation.locationServicesEnabled) {
	alert('現在地を確認できません。\n設定で位置情報が禁止されているか、\n位置情報機能を持たない機種です。');
}
var dist = function (lon1, lat1, lon2, lat2) {
	return Math.sqrt(Math.pow((lon1 - lon2) / 0.0091, 2) + Math.pow((lat1 - lat2) / 0.0111, 2));	// km
};
var location_r0 = {};
var location_r1 = {};
var location_m0 = {};
var location_m1 = {};
var updateLocation = function (location) {
	location_r1 = location;
	location_m1.latitude = location_m0.latitude + ((location_r1.latitude - location_r0.latitude) * (1 << (20 - zoom[index]))); 
	location_m1.longitude = location_m0.longitude + ((location_r1.longitude - location_r0.longitude) * (1 << (20 - zoom[index])));
/*
notify(zoom[index] + '\n' + (1 << (20 - zoom[index])) + '\n'
 + location_r0.latitude + '\n' + location_r1.latitude + '\n' + location_m0.latitude + '\n' + location_m1.latitude + '\n' + (location_r1.latitude - location_r0.latitude) + '\n' + ((location_r1.latitude - location_r0.latitude) * (1 << (20 - zoom[index]))) + '\n'
 + location_r0.longitude + '\n' + location_r1.longitude + '\n' + location_m0.longitude + '\n' + location_m1.longitude + '\n' + (location_r1.longitude - location_r0.longitude) + '\n' + ((location_r1.longitude - location_r0.longitude) * (1 << (20 - zoom[index]))) + '\n');
Ti.API.info(zoom[index] + '\n' + (1 << (20 - zoom[index])) + '\n'
 + location_r0.latitude + '\n' + location_r1.latitude + '\n' + location_m0.latitude + '\n' + location_m1.latitude + '\n' + (location_r1.latitude - location_r0.latitude) + '\n' + ((location_r1.latitude - location_r0.latitude) * (1 << (20 - zoom[index]))) + '\n'
 + location_r0.longitude + '\n' + location_r1.longitude + '\n' + location_m0.longitude + '\n' + location_m1.longitude + '\n' + (location_r1.longitude - location_r0.longitude) + '\n' + ((location_r1.longitude - location_r0.longitude) * (1 << (20 - zoom[index]))) + '\n');
*/
	webview.evalJS('map.panTo(new google.maps.LatLng(' + location_m1.latitude + ',' + location_m1.longitude + '))');
};
var lasttime = null;
var handleLocation = function (e) {
	if (! e.success || e.error) {
		notify('現在地を確認できません。' + ((e.error && e.error.message) ? ('\n' + e.error.message) : ''));
	} else if (! lasttime) {
		lasttime = e.devicetime;
		location_r0.latitude = e.coords.latitude;
		location_r0.longitude = e.coords.longitude;
		location_m0.latitude = e.coords.latitude;
		location_m0.longitude = e.coords.longitude;
		updateLocation(e.coords);
	} else if (e.devicetime) {
		updateLocation(e.coords);
	}
};
var locationCallback = function (e) {
	e.devicetime = (new Date()).getTime();	// GPS time != device time
	handleLocation(e);
}
Ti.Geolocation.purpose = '現在地に応じたマップ移動のため';	// for iOS4+
Ti.Geolocation.preferredProvider = Ti.Geolocation.PROVIDER_GPS;	// for Android
Ti.Geolocation.frequency = 1;	// for Android
Ti.Geolocation.accuracy = Ti.Geolocation.ACCURACY_BEST;
Ti.Geolocation.removeEventListener('location', locationCallback);
Ti.Geolocation.addEventListener('location', locationCallback);
setTimeout(function () {
	if (! lasttime) { alert('現在地を確認できません。\n上空がよく見通せる屋外で再度試してください。\n電源オフ・オンで改善することもあります。'); }
}, 90000);	// check timeout by App because Android OS GPS location event is not timeout
